// Export animation data from Layout to .chan format which Nuke can read
// 2009.11.19 first version
//
// Petter Sundnes
// petter@mentalfish.com

@version 2.7
@warnings
@script generic
@asyncspawn
@name "MF Export Chan"

generic
{
	thisScene = Scene();
	sceneItem;
	(sceneItem) = thisScene.getSelect();
	if(!sceneItem.isCamera())
	{
		info("Just letting you know that a camera is not selected.");
	}
	
	reqbegin("MentalFish Chan Exporter");
		reqsize(250,60);
		chanFile = ctlfilename("Save Chan", "", 30, 0);
		return if !reqpost();
			fileName = getvalue(chanFile);
	reqend();

	frameStart = 1;
	frameEnd = thisScene.renderend;
	fps = thisScene.fps;

	content = "";
	frameCount = 0;
	for(n = 1;n <= frameEnd;n++)
	{
		RefreshNow();
		time = n / fps;
		frameCount++;
		xPos[frameCount] = sceneItem.getWorldPosition(time).x;
		yPos[frameCount] = sceneItem.getWorldPosition(time).y;
		zPos[frameCount] = sceneItem.getWorldPosition(time).z*-1;
		xRot[frameCount] = sceneItem.getWorldRotation(time).p*-1;
		yRot[frameCount] = sceneItem.getWorldRotation(time).h*-1;
		zRot[frameCount] = sceneItem.getWorldRotation(time).b;
		xScale[frameCount] = sceneItem.getScaling(time).x;
		yScale[frameCount] = sceneItem.getScaling(time).y;
		zScale[frameCount] = sceneItem.getScaling(time).z;
	}
	
	for(n = 1;n <= frameCount; n++)
	{
		content = string(content, n, "\t", xPos[n], "\t", yPos[n], "\t", zPos[n], "\t", xRot[n], "\t", yRot[n], "\t", zRot[n], "\n");
	}

	if(strright(fileName,5) != ".chan")
		fileName = string(fileName, ".chan");
	filedelete(fileName);
	fout = File(fileName,"a");
	fout.writeln(content);
}