// Export animation data from Layout to .chan format which Nuke can read
// 2009.11.19 first version
//
// Petter Sundnes
// petter@mentalfish.com

@version 2.7
@warnings
@script generic
@asyncspawn
@name "MF Import Chan"

generic
{

				thisScene = Scene();
				sceneItem;
				(sceneItem) = thisScene.getSelect();
				if(!sceneItem.isCamera())
				{
								info("Just letting you know that a camera is not selected.");
				}
				fps = thisScene.fps;
				
				reqbegin("MentalFish Chan Exporter");
								reqsize(250,60);
								chanFile = ctlfilename("Open Chan", "", 30, 1);
								return if !reqpost();
								fileName = getvalue(chanFile);
				reqend();
	
				var chanFile = File(fileName,"r");
				var lineRead = chanFile.read();

				while(lineRead != nil)
				{
								dataSplit = parse(" \t",lineRead);
								currFrame = number(dataSplit[1]);
								currTime = currFrame / fps;
								xPos = number(dataSplit[2]);
								yPos = number(dataSplit[3]);
								zPos = number(dataSplit[4]);
								xRot = number(dataSplit[5]);
								yRot = number(dataSplit[6]);
								zRot = number(dataSplit[7]);
								
								posX = sceneItem.firstChannel();
								posY = sceneItem.nextChannel();
								posZ = sceneItem.nextChannel();
								rotX = sceneItem.nextChannel();
								rotY = sceneItem.nextChannel();
								rotZ = sceneItem.nextChannel();
								
								posX.createKey(currTime,xPos);
								posY.createKey(currTime,yPos);
								posZ.createKey(currTime,zPos*-1);
								rotX.createKey(currTime,yRot*-1);
								rotY.createKey(currTime,xRot*-1);
								rotZ.createKey(currTime,zRot);		
								
								lineRead = chanFile.read();
				}

}